//----< depMatrix.cpp > ---------------------------------------------
//---- Author: Qiang Zheng ------------------------------------------
//
// About the definition and the explanation, please see the depMatrix.h

#include "depMatrix.h"

// constructors
depMatrix::depMatrix()
{
	size = 40;
	depMatrix(size);
}

depMatrix::depMatrix(int matrixSize)
{
	size = matrixSize;
	fileNum = 0;
	// char* fileName[size];
	// bool fileMatrix[size][size];
}
	
// destructor
depMatrix::~depMatrix() {delete dependence[][]; delete fileNames[]; }

//return the number of the files in the matrix
int depMatrix::getCurFileNum() {return fileNum;}

void depMatrix::displayDepFiles(char* fName)
{
	if(indexOf(fName) == -1) { cout << "file: " << fName << "doesn't exist"; exit(-1);}
	displayDepFiles(indexOf(fName));
}

char* depMatrix::getFileName(int index){return(fileNames[index]);}

int depMatrix::indexOf(char* fName)
{
	for(int i = 0; i < fileNum; i++)
		if(strcmp(fileNames[i], fName) == 0)	return i;
		return -1;
}

void depMatrix::resize(int newsize)
{
	bool newMatrix[newsize][newsize];
	char* newFileNames[newsize];
	for(int i = 0; i < size; i++) {
		newFileNames[i] = fileNames[i];
		for(int j = 0; j < size; j++)
			newMatrix[i][j] = dependence[i][j];
	}
	delete[][] dependence;	dependence = newMatrix;
	delete[] fileNames;	fileNames = newFileNames;
	size = newsize;
}
	
void depMatrix::dislayDepFiles(int fileIdx)
{
	for(int j=0; j < fileNum; j++)
		if(dependence[fileIdx][j])
			cout << "    " << getFileName(j) << "\n";
}

// add a file to the matrix and adjust the dependece matrix.
//void depMatrix::addFile(const vector< bool > depVec)
void depMatrix::addFile(const vector depVec)
{
	if(++fileNum > size || depVec.size() > size) {resize(size * 2);}

	//add a row into the matrix
	for(int i = 0; i < size; i++) {
		dependence[fileNum - 1][i] = depArray[i];
	}

	// if this file is dependent on the files which already appeared
	// in the dependence matrix, then inherit the dependencies
	for(int i = 0; i < fileNum-2; i++) {
		if(dependence[fileNum - 1][j]) {
			for(int j = 0; j < size-1; j++)
				dependence[fileNum - 1][j] |= dependence[i][j];
		}
	}
	// if one of the files which already appeared in the matrix depends
	// on the new file just added, then dependencies of the new file are
	// inherited
	for(int i = 0; i < fileNum-2; i++)
		if(dependence[i][fileNum-1])
			for(int j = 0; j < size - 1; j++)
				dependence[i][j] |= dependence[fileNum - 1][j];
}
